<?php

/**
 * Table tl_popup 
 */
$GLOBALS['TL_DCA']['tl_popup'] = array
    (
    // Config
    'config' => array
        (
        'dataContainer' => 'Table',
        'ctable' => array('tl_content'),
        'ptable' => 'tl_popup_set',
        'switchToEdit' => true,
        'enableVersioning' => true,
        'sql' => array
            (
            'keys' => array
                (
                'id' => 'primary',
                'pid' => 'index'
            )
        )
    ),
    // List
    'list' => array
        (
        'sorting' => array
            (
            'mode' => 4,
            'fields' => array('sorting'),            
            'headerFields' => array('title', 'tstamp', 'protected'),
            'panelLayout' => 'search,limit',
            'child_record_callback' => array('tl_popup', 'showPreview'),
            'child_record_class' => 'no_padding'
        ),
        'global_operations' => array
            (
            'all' => array
                (
                'label' => &$GLOBALS['TL_LANG']['MSC']['all'],
                'href' => 'act=select',
                'class' => 'header_edit_all',
                'attributes' => 'onclick="Backend.getScrollOffset()" accesskey="e"'
            )
        ),
        'operations' => array
            (
            'edit' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup']['edit'],
                'href' => 'table=tl_content',
                'icon' => 'edit.gif'
            ),
            'editmeta' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup']['editmeta'],
                'href' => 'act=edit',
                'icon' => 'header.gif',
                'attributes' => 'class="edit-header"'
            ),
            'copy' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup']['copy'],
                'href' => 'act=paste&amp;mode=copy',
                'icon' => 'copy.gif'
            ),
            'cut' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup']['cut'],
                'href' => 'act=paste&amp;mode=cut',
                'icon' => 'cut.gif'
            ),
            'delete' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup']['delete'],
                'href' => 'act=delete',
                'icon' => 'delete.gif',
                'attributes' => 'onclick="if(!confirm(\'' . ($GLOBALS['TL_LANG']['MSC']['deleteConfirm'] ?? null) . '\'))return false;Backend.getScrollOffset()"'
            ),
            'toggle' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup']['toggle'],
                'icon' => 'visible.gif',
                'attributes' => 'onclick="Backend.getScrollOffset();return AjaxRequest.toggleVisibility(this,%s)"',
                'button_callback' => array('tl_popup', 'toggleIcon')
            ), 
            'show' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup']['show'],
                'href' => 'act=show',
                'icon' => 'show.gif'
            )
        )
    ),
    // Palettes
    'palettes' => array
        (
        '__selector__' => array('darkenPage'),
        'default' => '{title_legend},title,customId,pages;{position_legend},position;{appearance_legend},appearance,delay,scrollOffset,cookieExpire;{animation_legend},animationIn,animationOut,animationInSpeed,animationOutSpeed,darkenPage;{expert_legend:hide},cssClass,template;{publish_legend},published,start,stop'
    ),
    // Palettes
    'subpalettes' => array
        (
        'darkenPage' => 'darkenAnimationIn,darkenAnimationOut,darkenAnimationInSpeed,darkenAnimationOutSpeed,darkenerClickToClose'
    ),
    // Fields
    'fields' => array
        (
        'id' => array
            (
            'sql' => "int(10) unsigned NOT NULL auto_increment"
        ),
        'pid' => array
            (
            'foreignKey' => 'tl_popup_set.title',
            'sql' => "int(10) unsigned NOT NULL default '0'",
            'relation' => array('type' => 'belongsTo', 'load' => 'eager')
        ),
        'tstamp' => array
            (
            'sql' => "int(10) unsigned NOT NULL default '0'"
        ),
        'sorting' => array
            (
            'sql' => "int(10) unsigned NOT NULL default '0'"
        ),
        'title' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['title'],
            'exclude' => true,
            'search' => true,
            'sorting' => false,
            'flag' => 1,
            'inputType' => 'text',
            'eval' => array('mandatory' => true, 'maxlength' => 255, 'tl_class' => 'w50'),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'customId' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['customId'],
            'inputType' => 'text',
            'eval' => array('maxlength' => 255, 'tl_class' => 'w50'),
            'save_callback' => array
            (
                array('tl_popup', 'generateCustomId')
            ),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'pages' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['pages'],
            'exclude'                 => true,
            'inputType'               => 'pageTree',
            'eval'                    => array('multiple'=>true, 'fieldType'=>'checkbox', 'mandatory' => false, 'tl_class' => 'clr'),
            'sql'                     => "blob NULL",
            //'save_callback' => array
            //    (
            //    array('tl_popup', 'saveSliderPages'),
            //)
        ),
        'position' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['position'],
            'default'               => 'center',
            'exclude'               => true,
            'inputType'             => 'radioTable',
            'options'               => array('center', 'top-left', 'top-right', 'bottom-left', 'bottom-right'),
            'eval'                  => array('mandatory' => true, 'cols'=>5),
            //'reference'             => &$GLOBALS['TL_LANG']['tl_popup'],
            'sql'                   => "varchar(32) NOT NULL default ''"
        ),
        'darkenPage' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['darkenPage'],
            'exclude'               => true,
            'inputType'             => 'checkbox',
            'eval'                  => array('submitOnChange'=>true, 'tl_class'=>'clr'),
            'sql'                   => "char(1) NOT NULL default ''"
        ),
        'darkenAnimationIn' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['darkenAnimationIn'],
            'default'               => $GLOBALS['tl_popup']['animationsInDefault'],
            'exclude'               => true,
            'inputType'             => 'select',
            'options'               => $GLOBALS['tl_popup']['animationsIn'],
            'eval'                  => array('tl_class'=>'w50'),
            'sql'                   => "varchar(64) NOT NULL default ''"
        ),
        'darkenAnimationOut' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['darkenAnimationOut'],
            'default'               => $GLOBALS['tl_popup']['animationsOutDefault'],
            'exclude'               => true,
            'inputType'             => 'select',
            'options'               => $GLOBALS['tl_popup']['animationsOut'],
            'eval'                  => array('tl_class'=>'w50'),
            'sql'                   => "varchar(64) NOT NULL default ''"
        ),
        'darkenAnimationInSpeed' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['darkenAnimationIn'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '1000'"
        ),
        'darkenAnimationOutSpeed' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['darkenAnimationOut'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '1000'"
        ),
        'darkenerClickToClose' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['darkenerClickToClose'],
            'exclude' => true,
            'inputType' => 'checkbox',
            'eval' => array('doNotCopy' => true),
            'sql' => "char(1) NOT NULL default '0'"
        ),
        'appearance' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['appearance'],
            'default'               => 'onPageLoad',
            'exclude'               => true,
            'inputType'             => 'radio',
            'options'               => array(
                                        'onPageLoad' => &$GLOBALS['TL_LANG']['tl_popup']['appearance']['onPageLoad'], 
                                        'onScroll' => &$GLOBALS['TL_LANG']['tl_popup']['appearance']['onScroll']
                                        ),
            'eval'                  => array('mandatory' => true, 'tl_class'=>'clr'),
            'sql'                   => "char(200) NOT NULL default ''"
        ),
        'delay' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['delay'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers delay', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '1000'"
        ),
        'scrollOffset' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['scrollOffset'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers scrollOffset', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '300'"
        ),
        'cookieExpire' => array 
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['cookieExpire'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('mandatory' => true, 'tl_class'=>'w50 validateNumbers', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '7'"
        ),
        'animationIn' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['animationIn'],
            'default'               => $GLOBALS['tl_popup']['animationsInDefault'],
            'exclude'               => true,
            'inputType'             => 'select',
            'options'               => $GLOBALS['tl_popup']['animationsIn'],
            'eval'                  => array('tl_class'=>'w50'),
            'sql'                   => "varchar(64) NOT NULL default ''"
        ),
        'animationOut' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['animationOut'],
            'default'               => $GLOBALS['tl_popup']['animationsOutDefault'],
            'exclude'               => true,
            'inputType'             => 'select',
            'options'               => $GLOBALS['tl_popup']['animationsOut'],
            'eval'                  => array('tl_class'=>'w50'),
            'sql'                   => "varchar(64) NOT NULL default ''"
        ),
        'animationInSpeed' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['animationIn'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '1000'"
        ),
        'animationOutSpeed' => array
            (
            'label'                 => &$GLOBALS['TL_LANG']['tl_popup']['animationOut'],
            'exclude'               => true,
            'inputType'             => 'text',
            'eval'                  => array('tl_class'=>'w50 validateNumbers', 'rgxp'=>'digit'),
            'sql'                   => "varchar(5) NOT NULL default '1000'"
        ),
        'cssClass' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['cssClass'],
            'exclude' => true,
            'inputType' => 'text',
            'eval' => array('tl_class'=>'clr w50'),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'template' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['template'],
            'exclude' => true,
            'inputType' => 'select',
            'options_callback' => array('tl_popup', 'getPopupTemplates'),
            'eval' => array('tl_class'=>'w50'),
            'sql' => "varchar(64) NOT NULL default 'popup_default'"
        ),
        'published' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['published'],
            'exclude' => true,
            'filter' => true,
            'flag' => 1,
            'inputType' => 'checkbox',
            'eval' => array('doNotCopy' => true),
            'sql' => "char(1) NOT NULL default ''"
        ),
        'start' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['start'],
            'exclude' => true,
            'inputType' => 'text',
            'eval' => array('rgxp' => 'datim', 'datepicker' => true, 'tl_class' => 'w50 wizard'),
            'sql' => "varchar(10) NOT NULL default ''"
        ),
        'stop' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup']['stop'],
            'exclude' => true,
            'inputType' => 'text',
            'eval' => array('rgxp' => 'datim', 'datepicker' => true, 'tl_class' => 'w50 wizard'),
            'sql' => "varchar(10) NOT NULL default ''"
        )
    )
);

/**
 * Class tl_popup
 */
class tl_popup extends Backend {

    /**
     * Import the back end user object
     */
    public function __construct() {
        parent::__construct();
        $this->import('BackendUser', 'User');
    }

    /**
     * Check permissions to edit table tl_popup
     */
    public function checkPermission() {
        
        if ($this->User->isAdmin) {
            return;
        }

        // Set the root IDs
        if (!is_array($this->User->menus) || empty($this->User->menus)) {
            $root = array(0);
        } else {
            $root = $this->User->menus;
        }

        $id = strlen(Input::get('id')) ? Input::get('id') : CURRENT_ID;

        // Check current action
        switch (Input::get('act')) {
            case 'paste':
                // Allow
                break;

            case 'create':
                if (!strlen(Input::get('pid')) || !in_array(Input::get('pid'), $root)) {
                    $this->log('Not enough permissions to create menu items in menu set ID "' . Input::get('pid') . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;

            case 'cut':
            case 'copy':
                if (!in_array(Input::get('pid'), $root)) {
                    $this->log('Not enough permissions to ' . Input::get('act') . ' menu item ID "' . $id . '" to menu set ID "' . Input::get('pid') . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
            // NO BREAK STATEMENT HERE

            case 'edit':
            case 'show':
            case 'delete':            
            case 'feature':
                $objArchive = $this->Database->prepare("SELECT pid FROM tl_popup WHERE id=?")
                        ->limit(1)
                        ->execute($id);

                if ($objArchive->numRows < 1) {
                    $this->log('Invalid menu item ID "' . $id . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }

                if (!in_array($objArchive->pid, $root)) {
                    $this->log('Not enough permissions to ' . Input::get('act') . ' menu item ID "' . $id . '" of menu set ID "' . $objArchive->pid . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;

            case 'toggle':
                // did not work as part of the group above
                if (!in_array('tl_popup::published', $this->User->alexf)) {
                    $this->log('Not enough permissions to ' . Input::get('act') . ' menu item ID "' . $id . '" of menu set ID "' . $objArchive->pid . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;     
                
            case 'select':
            case 'editAll':
            case 'deleteAll':
            case 'overrideAll':
            case 'cutAll':
            case 'copyAll':
                if (!in_array($id, $root)) {
                    $this->log('Not enough permissions to access menu set ID "' . $id . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }

                $objArchive = $this->Database->prepare("SELECT id FROM tl_popup WHERE pid=?")
                        ->execute($id);

                if ($objArchive->numRows < 1) {
                    $this->log('Invalid menu set ID "' . $id . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }

                $session = $this->Session->getData();
                $session['CURRENT']['IDS'] = array_intersect($session['CURRENT']['IDS'], $objArchive->fetchEach('id'));
                $this->Session->setData($session);
                break;

            default:
                if (strlen(Input::get('act'))) {
                    $this->log('Invalid command "' . Input::get('act') . '"', 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                } elseif (!in_array($id, $root)) {
                    $this->log('Not enough permissions to access menu set ID ' . $id, 'tl_popup checkPermission', TL_ERROR);
                    $this->redirect('contao/main.php?act=error');
                }
                break;
        }
    }
    
    /**
     * Add the type of input field
     * @param array
     * @return string
     */
    public function showPreview($arrRow) {

        $period = "";
        if ($arrRow['start']) {
            $period .= '<span class="start">Start: ' . date("d-m-Y H:i",$arrRow['start']) . '</span>';
        }
        if ($arrRow['stop']) {
            $period .= '<span class="stop">Stop: ' . date("d-m-Y H:i",$arrRow['stop']) . '</span>';
        }

        return '<div class="tl_content_left tl_popup">' . $arrRow['title'] . '<br><span class="period">'.$period.'</span></div>';
    }

    /**
     * Get all articles and return them as array
     * @param \DataContainer
     * @return array
     */
    public function getArticleAlias(DataContainer $dc) {
        $arrPids = array();
        $arrAlias = array();

        if (!$this->User->isAdmin) {
            foreach ($this->User->pagemounts as $id) {
                $arrPids[] = $id;
                $arrPids = array_merge($arrPids, $this->Database->getChildRecords($id, 'tl_page'));
            }

            if (empty($arrPids)) {
                return $arrAlias;
            }

            $objAlias = $this->Database->prepare("SELECT a.id, a.title, a.inColumn, p.title AS parent FROM tl_article a LEFT JOIN tl_page p ON p.id=a.pid WHERE a.pid IN(" . implode(',', array_map('intval', array_unique($arrPids))) . ") ORDER BY parent, a.sorting")
                    ->execute($dc->id);
        } else {
            $objAlias = $this->Database->prepare("SELECT a.id, a.title, a.inColumn, p.title AS parent FROM tl_article a LEFT JOIN tl_page p ON p.id=a.pid ORDER BY parent, a.sorting")
                    ->execute($dc->id);
        }

        if ($objAlias->numRows) {
            $this->loadLanguageFile('tl_article');

            while ($objAlias->next()) {
                $arrAlias[$objAlias->parent][$objAlias->id] = $objAlias->title . ' (' . ($GLOBALS['TL_LANG']['tl_article'][$objAlias->inColumn] ? : $objAlias->inColumn) . ', ID ' . $objAlias->id . ')';
            }
        }

        return $arrAlias;
    }

    /**
     * Return the link picker wizard
     * @param \DataContainer
     * @return string
     */
    public function pagePicker(DataContainer $dc) {
        return ' <a href="contao/page.php?do=' . Input::get('do') . '&amp;table=' . $dc->table . '&amp;field=' . $dc->field . '&amp;value=' . str_replace(array('{{link_url::', '}}'), '', $dc->value) . '" onclick="Backend.getScrollOffset();Backend.openModalSelector({\'width\':765,\'title\':\'' . specialchars(str_replace("'", "\\'", $GLOBALS['TL_LANG']['MOD']['page'][0])) . '\',\'url\':this.href,\'id\':\'' . $dc->field . '\',\'tag\':\'ctrl_' . $dc->field . ((Input::get('act') == 'editAll') ? '_' . $dc->id : '') . '\',\'self\':this});return false">' . $this->generateImage('pickpage.gif', $GLOBALS['TL_LANG']['MSC']['pagepicker'], 'style="vertical-align:top;cursor:pointer"') . '</a>';
    }
    
    /**
     * Return the "toggle visibility" button
     * @param array
     * @param string
     * @param string
     * @param string
     * @param string
     * @param string
     * @return string
     */
    public function toggleIcon($row, $href, $label, $title, $icon, $attributes) {
        if (strlen(Input::get('tid'))) {
            $this->toggleVisibility(Input::get('tid'), (Input::get('state') == 1));
            $this->redirect($this->getReferer());
        }

        // Check permissions AFTER checking the tid, so hacking attempts are logged
        if (!$this->User->isAdmin && !$this->User->hasAccess('tl_popup::published', 'alexf')) {
            return '';
        }

        $href .= '&amp;tid=' . $row['id'] . '&amp;state=' . ($row['published'] ? '' : 1);

        if (!$row['published']) {
            $icon = 'invisible.gif';
        }

        return '<a href="' . $this->addToUrl($href) . '" title="' . specialchars($title) . '"' . $attributes . '>' . $this->generateImage($icon, $label) . '</a> ';
    }

    /**
     * Disable/enable a room
     * @param integer
     * @param boolean
     */
    public function toggleVisibility($intId, $blnVisible) {
        // Check permissions to edit
        Input::setGet('id', $intId);
        Input::setGet('act', 'toggle');
        // avoid undefined method error for now
        $this->checkPermission();
        // Check permissions to publish
        if (!$this->User->isAdmin && !$this->User->hasAccess('tl_popup::published', 'alexf')) {
            $this->log('Not enough permissions to publish/unpublish project item ID "' . $intId . '"', 'tl_popup toggleVisibility', TL_ERROR);
            $this->redirect('contao/main.php?act=error');
        }

        $this->createInitialVersion('tl_popup', $intId);

        // Trigger the save_callback
        if (is_array($GLOBALS['TL_DCA']['tl_popup']['fields']['published']['save_callback'])) {
            foreach ($GLOBALS['TL_DCA']['tl_popup']['fields']['published']['save_callback'] as $callback) {
                $this->import($callback[0]);
                $blnVisible = $this->$callback[0]->$callback[1]($blnVisible, $this);
            }
        }

        // Update the database
        $this->Database->prepare("UPDATE tl_popup SET tstamp=" . time() . ", published='" . ($blnVisible ? 1 : '') . "' WHERE id=?")
                ->execute($intId);

        $this->createNewVersion('tl_popup', $intId);
    }

    /**
     * Auto-generate the popup custom id if it has not been set yet
     *
     * @param mixed                $varValue
     * @param Contao\DataContainer $dc
     *
     * @return string
     *
     * @throws Exception
     */
    public function generateCustomId($varValue, Contao\DataContainer $dc)
    {
        

        $aliasExists = function (string $alias) use ($dc): bool
        {
            return $this->Database->prepare("SELECT id FROM tl_popup WHERE customId=? AND id!=?")->execute($alias, $dc->id)->numRows > 0;
        };

        // Generate alias if there is none
        if ($varValue == '')
        {
            $varValue = substr(md5(uniqid(rand(), true)), 0, 8); // returns random 8 character long string
        }
        elseif ($aliasExists($varValue))
        {
            throw new Exception(sprintf($GLOBALS['TL_LANG']['ERR']['aliasExists'], $varValue));
        }

        return $varValue;
    }

    /**
     * Return all popup templates as array
     *
     * @return array
     */
    public function getPopupTemplates()
    {
        return $this->getTemplateGroup('popup_');
    }


}