<?php

/**
 * Table tl_popup_set 
 */
$GLOBALS['TL_DCA']['tl_popup_set'] = array
    (
    // Config
    'config' => array
        (
        'dataContainer' => 'Table',
        'ctable' => array('tl_popup'),
        'switchToEdit' => true,
        'enableVersioning' => true,
        'sql' => array
            (
            'keys' => array
                (
                'id' => 'primary'
            )
        )
    ),
    // List
    'list' => array
        (
        'sorting' => array
            (
            'mode' => 1,
            'fields' => array('title'),
            'flag' => 1,
            'panelLayout' => 'search,limit'
        ),
        'label' => array
            (
            'fields' => array('title'),
            'format' => '%s'
        ),
        'global_operations' => array
            (
            'all' => array
                (
                'label' => &$GLOBALS['TL_LANG']['MSC']['all'],
                'href' => 'act=select',
                'class' => 'header_edit_all',
                'attributes' => 'onclick="Backend.getScrollOffset()" accesskey="e"'
            )
        ),
        'operations' => array
            (
            'edit' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['edit'],
                'href' => 'table=tl_popup',
                'icon' => 'edit.gif',
                'attributes' => 'class="contextmenu"'
            ),
            'editheader' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['editheader'],
                'href' => 'act=edit',
                'icon' => 'header.gif',
                'button_callback' => array('tl_popup_set', 'editHeader'),
                'attributes' => 'class="edit-header"'
            ),
            'copy' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['copy'],
                'href' => 'act=copy',
                'icon' => 'copy.gif',
                'button_callback' => array('tl_popup_set', 'copySet')
            ),
            'delete' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['delete'],
                'href' => 'act=delete',
                'icon' => 'delete.gif',
                'attributes' => 'onclick="if(!confirm(\'' . ($GLOBALS['TL_LANG']['MSC']['deleteConfirm'] ?? null) . '\'))return false;Backend.getScrollOffset()"',
                'button_callback' => array('tl_popup_set', 'deleteSet')
            ),
            'show' => array
                (
                'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['show'],
                'href' => 'act=show',
                'icon' => 'show.gif'
            )
        )
    ),
    // Palettes
    'palettes' => array
        (
        '__selector__' => array('protected'),
        'default' => '{title_legend},title;{protected_legend:hide},protected'
    ),
    // Fields
    'fields' => array
        (
        'id' => array
            (
            'sql' => "int(10) unsigned NOT NULL auto_increment"
        ),
        'tstamp' => array
            (
            'sql' => "int(10) unsigned NOT NULL default '0'"
        ),
        'title' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['title'],
            'exclude' => true,
            'search' => true,
            'sorting' => true,
            'flag' => 1,
            'inputType' => 'text',
            'eval' => array('mandatory' => true, 'maxlength' => 255),
            'sql' => "varchar(255) NOT NULL default ''"
        ),
        'protected' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['protected'],
            'exclude' => true,            
            'inputType' => 'checkbox',
            'eval' => array('submitOnChange' => true),
            'sql' => "char(1) NOT NULL default ''"
        ),
        'groups' => array
            (
            'label' => &$GLOBALS['TL_LANG']['tl_popup_set']['groups'],
            'exclude' => true,
            'inputType' => 'checkbox',
            'foreignKey' => 'tl_member_group.name',
            'eval' => array('mandatory' => true, 'multiple' => true),
            'sql' => "blob NULL",
            'relation' => array('type' => 'hasMany', 'load' => 'lazy')
        )        
    )
);

/**
 * Class tl_popup_set
 */
class tl_popup_set extends Backend
{

	/**
	 * Import the back end user object
	 */
	public function __construct()
	{
		parent::__construct();
		$this->import('BackendUser', 'User');
	}

	/**
	 * Return the edit header button
	 * @param array
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @return string
	 */
	public function editHeader($row, $href, $label, $title, $icon, $attributes)
	{
		return ($this->User->isAdmin || count(preg_grep('/^tl_popup_set::/', $this->User->alexf)) > 0) ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.specialchars($title).'"'.$attributes.'>'.$this->generateImage($icon, $label).'</a> ' : '';
	}


	/**
	 * Return the copy set button
	 * @param array
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @return string
	 */
	public function copySet($row, $href, $label, $title, $icon, $attributes)
	{
		return ($this->User->isAdmin) ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.specialchars($title).'"'.$attributes.'>'.$this->generateImage($icon, $label).'</a> ' : $this->generateImage(preg_replace('/\.gif$/i', '_.gif', $icon)).' ';
	}


	/**
	 * Return the delete set button
	 * @param array
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @param string
	 * @return string
	 */
	public function deleteSet($row, $href, $label, $title, $icon, $attributes)
	{
		return ($this->User->isAdmin) ? '<a href="'.$this->addToUrl($href.'&amp;id='.$row['id']).'" title="'.specialchars($title).'"'.$attributes.'>'.$this->generateImage($icon, $label).'</a> ' : $this->generateImage(preg_replace('/\.gif$/i', '_.gif', $icon)).' ';
	}
}
